// Variable
var variable = '';
const constante = '';
let variableScoped = '';

// Types primaires
let string = '';
let number = 0;
let boolean = true;

let array = ['JohnDoe', 'JaneDoe'];
let object = {
    username: '',
};

// N.B. les tableaux et les objets sont passés par référence
const user = {
    username: 'JohnDoe',
};
const user2 = user;
user2.username = 'JaneDoe';

console.log(user.username);

// Solution
const user3 = { ...user };
const array2 = [...array];

// Fonctions
console.log(add(1, 2));

function add (nb1, nb2) {
    return nb1 + nb2;
}

// Fonction anonymes

// Fonction anonyme simple
const add2 = function (nb1, nb2) {
    return nb1 + nb2;
};

// Fonction anonyme fléchée
const add3 = (nb1, nb2) => nb1 + nb2;

/*
Fonction fléchées spécificités
1. Return implicite
2. Pas de this (pas très utile quand on débute)
 */

// Destructuring d'objet
const newUser = {
    username: 'username',
    firstName: 'John',
    lastName: 'Doe',
    address: {
        path: 'Main St',
        number: 123,
        city: 'Springfield',
        zipcode: '12345',
    },
};
const newUser2 = {
    username: 'username2',
    firstName: 'Jane',
    lastName: 'Doe',
    address: null,
};

const {lastName, firstName, username} = newUser
console.log(lastName, firstName, username);

const users = [
    {
        id: 1,
        username: 'naruto'
    },
    {
        id: 2,
        username: 'sasuke'
    },
    {
        id: 3,
        username: 'sakura'
    },
]

const usersId = users.map(({ id }) => id)

// Facultative chaining
const newUsers = [newUser, newUser2];
const addressNumbers = newUsers.map((user) => user.address?.number ?? -1);
console.log(addressNumbers);

document.querySelector('footer')
        ?.addEventListener('click', () => {
            console.log('ici');
        });

console.log('apres');