/**
 fetch('http://localhost:8000/api/recipes/detail.php?id=1')
 .then((response) => {
 return response.json()
 })
 .then((data) => {
 console.log(data);
 })
 **/

// async function loadData(){}

const loadData = async () => {
    const url = new URLSearchParams(window.location.search);
    const response = await fetch(`http://localhost:8000/api/recipes/detail.php?id=${url.get('id')}`);
    const data = await response.json();

    const main = document.querySelector('main');

    const title = document.createElement('h1');
    title.textContent = data.title;
    main.appendChild(title);

    const img = document.createElement('img');
    img.src = `/assets/img/${data.thumbnail}`;
    main.insertAdjacentElement('beforeend', img);

    const p = document.createElement('p');
    p.innerText = data.description;
    main.appendChild(p);
};

loadData();
