<?php

require_once 'Database.php';

class Recipe extends Database
{
    private string $path;

    public function __construct()
    {
        parent::__construct();

        $this->path = "{$_SERVER['DOCUMENT_ROOT']}/assets/img/save";

        $this->db->exec('CREATE TABLE IF NOT EXISTS recipe (
    id INTEGER PRIMARY KEY AUTOINCREMENT,
    title VARCHAR(100) NOT NULL,
    description TEXT NOT NULL,
    notation INTEGER,
    thumbnail VARCHAR(50) NOT NULL
)');
    }

    public function getPath(): string
    {
        return $this->path;
    }

    public function saveImg(): string
    {
        $time = time();
        $type = pathinfo($_FILES['thumbnail']['name'], PATHINFO_EXTENSION);
        $name = "{$time}.{$type}";

        move_uploaded_file($_FILES['thumbnail']['tmp_name'], "{$this->path}/{$name}");

        return $name;
    }

    public function save(string $title, string $description, string $name): void
    {
        $statement = $this->db->prepare("INSERT INTO recipe ('title', 'description', 'thumbnail') VALUES (:title, :description, :thumbnail)");

        $statement->bindValue(':title', $title);
        $statement->bindValue(':description', $description);
        $statement->bindValue(':thumbnail', $name);

        $statement->execute();
    }

    public function getAll()
    {
        return $this->db->query('SELECT * FROM recipe')->fetchAll();
    }

    public function get(string $id)
    {
        $stmt = $this->db->prepare('SELECT * FROM recipe WHERE id = :id');
        $stmt->bindValue(':id', $id);
        $stmt->execute();

        return $stmt->fetch();
    }
}